---
title: DOMMatrixReadOnly.translate()
slug: Web/API/DOMMatrixReadOnly/translate
tags:
  - API
  - DOMMatrix
  - DOMMatrixReadOnly
  - Experimental
  - Geometry
  - Geometry Interfaces
  - Interface
  - Method
  - Reference
  - Translate
  - matrix
---
<p>{{APIRef("Geometry Interfaces")}}{{seecompattable}}</p>

<p>The <code>translate()</code> method of the {{domxref("DOMMatrixReadOnly")}} interface creates a new matrix being the result of the original matrix with a translation applied.</p>

<h2 id="Syntax">Syntax</h2>

<p>The <code>translate()</code> method accepts two or three values.</p>

<pre class="syntaxbox">DOMMatrix.translate(<em>translateX</em>, <em>translateY</em>[, <em>translateZ]</em>)</pre>

<h3 class="highlight-spanned" id="Parameters"><span class="highlight-span">Parameters</span></h3>

<dl>
 <dt>translateX</dt>
 <dd>A number representing the abscissa (x-coordinate) of the translating vector.</dd>
 <dt>translateY</dt>
 <dd>A number representing the ordinate (y-coordinate) of the translating vector.</dd>
 <dt>translateZ <span class="inlineIndicator optional optionalInline">Optional</span></dt>
 <dd>A number representing the z component of the translating vector.  If not supplied, this defaults to 0.  If this is anything other than 0, the resulting matrix will be 3D.</dd>
</dl>

<h3 class="highlight-spanned" id="Return_value"><span class="highlight-span">Return value</span></h3>

<p>Returns a <a href="/en-US/docs/Web/API/DOMMatrix" title="The DOMMatrix interface represents 4x4 matrices, suitable for 2D and 3D operations."><code>DOMMatrix</code></a> containing a new matrix being the result of the matrix being translated by the given vector. The original matrix is not modified.</p>

<p>If a translation is applied about the z-axis, the resulting matrix will be a 4x4 3D matrix.</p>

<h2 id="Examples">Examples</h2>

<p>This SVG contains two squares, one red and one blue, each positioned at the document origin:</p>

<pre class="brush: html">&lt;svg width="250" height="250" viewBox="0 0 50 50"&gt;
  &lt;rect width="25" height="25" fill="red" /&gt;
  &lt;rect id="transformed" width="25" height="25" fill="blue" /&gt;
&lt;/svg&gt;</pre>

<p>The following JavaScript first creates an identity matrix, then uses the <code>translate()</code> method to create a new, translated matrix — which is then applied to the blue square as a <code>transform</code>. The red square is left in place.</p>

<pre class="brush: js">const matrix = new DOMMatrixReadOnly().translate(25, 25);

document.querySelector('#transformed').setAttribute('transform', matrix.toString());
</pre>

<p>{{ EmbedLiveSample('Examples', '250', '250', 'https://mdn.mozillademos.org/files/16525/Screen_Shot_2019-02-19_at_11.20.40.png', 'Web/API/DOMMatrixReadOnly/translate') }}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{ SpecName('Geometry Interfaces', '#dom-dommatrixreadonly-translate', 'DOMMatrixReadOnly.translate()') }}</td>
   <td>{{ Spec2('Geometry Interfaces') }}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.DOMMatrixReadOnly.translate")}}</p>
